From 563e3aa7be8dedceb91da811c7b335d3471e8b68 Mon Sep 17 00:00:00 2001
From: zubin choudhary <imzubin@localhost.localdomain>
Date: Jul 14 2019 13:48:52 +0000
Subject: [PATCH 7/18] login controller


---

diff --git a/src/LoginWindow.py b/src/LoginWindow.py
new file mode 100644
index 0000000..e746b7a
--- /dev/null
+++ b/src/LoginWindow.py
@@ -0,0 +1,63 @@
+# -*- coding: utf-8 -*-
+
+# Form implementation generated from reading ui file 'ui/Login.ui'
+#
+# Created by: PyQt5 UI code generator 5.13.0
+#
+# WARNING! All changes made in this file will be lost!
+
+
+from PyQt5 import QtCore, QtGui, QtWidgets
+
+
+class Ui_Login(object):
+    def setupUi(self, Login):
+        Login.setObjectName("Login")
+        Login.resize(250, 300)
+        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)
+        sizePolicy.setHorizontalStretch(0)
+        sizePolicy.setVerticalStretch(0)
+        sizePolicy.setHeightForWidth(Login.sizePolicy().hasHeightForWidth())
+        Login.setSizePolicy(sizePolicy)
+        Login.setMinimumSize(QtCore.QSize(250, 300))
+        Login.setMaximumSize(QtCore.QSize(250, 300))
+        self.gridLayoutWidget = QtWidgets.QWidget(Login)
+        self.gridLayoutWidget.setGeometry(QtCore.QRect(0, 0, 241, 291))
+        self.gridLayoutWidget.setObjectName("gridLayoutWidget")
+        self.gridLayout = QtWidgets.QGridLayout(self.gridLayoutWidget)
+        self.gridLayout.setContentsMargins(0, 0, 0, 0)
+        self.gridLayout.setObjectName("gridLayout")
+        self.Password = QtWidgets.QLineEdit(self.gridLayoutWidget)
+        self.Password.setText("")
+        self.Password.setEchoMode(QtWidgets.QLineEdit.Password)
+        self.Password.setObjectName("Password")
+        self.gridLayout.addWidget(self.Password, 5, 0, 1, 1)
+        self.label_username = QtWidgets.QLabel(self.gridLayoutWidget)
+        self.label_username.setObjectName("label_username")
+        self.gridLayout.addWidget(self.label_username, 2, 0, 1, 1)
+        self.label_Password = QtWidgets.QLabel(self.gridLayoutWidget)
+        self.label_Password.setObjectName("label_Password")
+        self.gridLayout.addWidget(self.label_Password, 4, 0, 1, 1)
+        self.fedoraReleases = QtWidgets.QComboBox(self.gridLayoutWidget)
+        self.fedoraReleases.setObjectName("fedoraReleases")
+        self.gridLayout.addWidget(self.fedoraReleases, 7, 0, 1, 1)
+        self.label_FeodraVersion = QtWidgets.QLabel(self.gridLayoutWidget)
+        self.label_FeodraVersion.setObjectName("label_FeodraVersion")
+        self.gridLayout.addWidget(self.label_FeodraVersion, 6, 0, 1, 1)
+        self.saveButton = QtWidgets.QPushButton(self.gridLayoutWidget)
+        self.saveButton.setObjectName("saveButton")
+        self.gridLayout.addWidget(self.saveButton, 8, 0, 1, 1)
+        self.Username = QtWidgets.QLineEdit(self.gridLayoutWidget)
+        self.Username.setObjectName("Username")
+        self.gridLayout.addWidget(self.Username, 3, 0, 1, 1)
+
+        self.retranslateUi(Login)
+        QtCore.QMetaObject.connectSlotsByName(Login)
+
+    def retranslateUi(self, Login):
+        _translate = QtCore.QCoreApplication.translate
+        Login.setWindowTitle(_translate("Login", "Login"))
+        self.label_username.setText(_translate("Login", "Username"))
+        self.label_Password.setText(_translate("Login", "Password"))
+        self.label_FeodraVersion.setText(_translate("Login", "Fedora Version"))
+        self.saveButton.setText(_translate("Login", "Save"))
diff --git a/src/main.py b/src/main.py
old mode 100644
new mode 100755
index ac827d5..cbc489f
--- a/src/main.py
+++ b/src/main.py
@@ -1,32 +1,48 @@
+#!/bin/python3
+
+
 # import system stuff
+import os
 import sys
 import json
 import pprint
-
-from window import Ui_MainWindow
+from pathlib import Path
+from ast import literal_eval
 
 # UI libs
 from PySide2 import QtCore, QtGui, QtWidgets
 from PyQt5 import QtCore, QtGui, QtWidgets
 
-# import login controller
-from login import Login 
+# import UI
+from window import Ui_MainWindow
+from LoginWindow import Ui_Login
+
 
 
 #  import Fedora libs
 from bodhi.client.bindings import BodhiClient
 
-
+location_data = str(Path.home()) + "/.fgk"
 
 
 class Main():
         def __init__(self):
+                
+                self.username = None
+                self.password = None
                 # init application
                 app = QtWidgets.QApplication(sys.argv)
+                self.error = QtWidgets.QApplication([])
                 MainWindow = QtWidgets.QMainWindow()
                 self.ui = Ui_MainWindow()
                 self.ui.setupUi(MainWindow)
                 
+                # login window
+                self.Login = QtWidgets.QDialog()
+                self.ui_login = Ui_Login()
+                self.ui_login.setupUi(self.Login)
+
+
                 # set assets
                 self.bugfix = QtGui.QPixmap("../assets/bugfix.png")
                 self.enhancement = QtGui.QPixmap("../assets/enhancement.png")
@@ -40,51 +56,116 @@ class Main():
                 self.ui.fetchUpdatesButton.clicked.connect(self.fetchList)
                 self.ui.nextButton.clicked.connect(self.next_page)
                 self.ui.previousButton.clicked.connect(self.previous_page)
+
+
+                # listeners loginPopup
+                self.ui_login.saveButton.clicked.connect(self.save)
+
+                # fedora Release
+                self.fedoraRelease = ["30","29"]
+                self.ui_login.fedoraReleases.addItems(self.fedoraRelease)
+                
+                # Get Login and fedora version
+                self.loginPopup()
+
                 # Bodhi
                 self.bc = BodhiClient()
 
 
-
-                self.query_args = {
-                        "page" : "1",
-                        "rows_per_page" : "30"
-                }
+                self.query_args = {}
+                self.query_args['rows_per_page'] = 30
+                self.query_args['page'] = 1
+                self.query_args['releases'] = "30"
 
                 MainWindow.show()
                 sys.exit(app.exec_())
         
 
 
+        def loginPopup(self):
+                self.Login.show()
+                return(0)
         
+
+        def save(self):
+                
+                self.username = self.ui_login.Username.text()
+                self.password = self.ui_login.Password.text()
+                self.query_args['releases'] = self.ui_login.fedoraReleases.currentText()     
+                print(self.username, self.password )
+                
+
+
+                self.Login.close()
+
         def postKarma(self):
                 t = self.ui.listWidget.selectedItems()
-                print(self.bc.get_releases())
-                print(t[0].text())
+                if (self.username == None or self.password == None):
+                                print("e")
+                                error_dialog = QtWidgets.QErrorMessage()
+                                error_dialog.showMessage("login first")
+                                # self.error.exec_()
+                else:
+                        try:
+                                self.bc1 = BodhiClient(base_url='https://bodhi.fedoraproject.org/', username=self.username, password=self.password)
+                                self.bc1.comment(t[0].text(), self.ui.commentEdit.toPlainText(), self.ui.karmaBox.currentText())
+                                print(self.username,self.password)
+                        
+                        except Exception as e:
+                                print(e)
+                                error_dialog = QtWidgets.QErrorMessage()
+                                error_dialog.showMessage(str(e))
+                                # self.error.exec_()
+                
                 pass
 
         
         
         # fetch the list of updates
-        def fetchList(self):
-                self.ui.listWidget.clear()
-                self.data = self.bc.query(page=self.query_args["page"],rows_per_page=self.query_args["rows_per_page"])
-                for p in self.data['updates']:
-                        self.ui.listWidget.addItem(p['title'])
+        def fetchList(self, cached_data):
+                try: 
+                        self.ui.listWidget.clear()
+                        if(cached_data):
+                                self.data = json.load(open(cached_data, "r"))
+                        else:
+                                self.data = self.bc.query(**self.query_args)
+                        for p in self.data['updates']:
+                                self.ui.listWidget.addItem(p['title'])
+                        self.cache()
+                except Exception as e:
+                        print(e)
+                        pass
+
 
         # page controllers 
         def next_page(self):
                 self.query_args["page"] = int(self.query_args["page"]) + 1
                 self.ui.PageNum.setText(str(self.query_args["page"]))
-
+                self.directory = location_data + "/" +self.query_args['releases'] + '/'+ str(self.query_args['page']) + ".json"
+                self.fetchList(self.directory)
 
         def previous_page(self):
                 if (int(self.query_args["page"]) > 1):
                         self.query_args["page"] = int(self.query_args["page"]) - 1
                 self.ui.PageNum.setText(str(self.query_args["page"]))
+                self.directory = location_data + "/" +self.query_args['releases'] + '/'+ str(self.query_args['page']) + ".json"
+                
+                self.fetchList(self.directory)
+
+
+        # cache function
+        def cache(self):
+                
+                self.directory = location_data + "/" +self.query_args['releases'] + '/'+ str(self.query_args['page']) + ".json"
+                
+                # check dir
+                os.makedirs(os.path.dirname( self.directory ), exist_ok=True)
+                with open(self.directory, "w") as f:
+                        f.write(json.dumps(self.data))
+                pass
 
-        
         # selecting the update
-        
+
         # populates comments in the section
         def populateComments(self, t):
                 try:
diff --git a/src/ui/Login.ui b/src/ui/Login.ui
index d44ab9c..f9bb4ee 100644
--- a/src/ui/Login.ui
+++ b/src/ui/Login.ui
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <ui version="4.0">
- <class>Dialog</class>
- <widget class="QDialog" name="Dialog">
+ <class>Login</class>
+ <widget class="QDialog" name="Login">
   <property name="geometry">
    <rect>
     <x>0</x>
@@ -31,77 +31,61 @@
   <property name="windowTitle">
    <string>Login</string>
   </property>
-  <widget class="QLineEdit" name="username">
+  <widget class="QWidget" name="gridLayoutWidget">
    <property name="geometry">
     <rect>
-     <x>10</x>
-     <y>70</y>
-     <width>231</width>
-     <height>35</height>
+     <x>0</x>
+     <y>0</y>
+     <width>241</width>
+     <height>291</height>
     </rect>
    </property>
-  </widget>
-  <widget class="QLineEdit" name="Password">
-   <property name="geometry">
-    <rect>
-     <x>10</x>
-     <y>140</y>
-     <width>231</width>
-     <height>35</height>
-    </rect>
-   </property>
-  </widget>
-  <widget class="QPushButton" name="Login">
-   <property name="geometry">
-    <rect>
-     <x>10</x>
-     <y>180</y>
-     <width>96</width>
-     <height>35</height>
-    </rect>
-   </property>
-   <property name="text">
-    <string>Login</string>
-   </property>
-  </widget>
-  <widget class="QPushButton" name="skip">
-   <property name="geometry">
-    <rect>
-     <x>140</x>
-     <y>180</y>
-     <width>96</width>
-     <height>35</height>
-    </rect>
-   </property>
-   <property name="text">
-    <string>Skip</string>
-   </property>
-  </widget>
-  <widget class="QLabel" name="label">
-   <property name="geometry">
-    <rect>
-     <x>10</x>
-     <y>120</y>
-     <width>141</width>
-     <height>19</height>
-    </rect>
-   </property>
-   <property name="text">
-    <string>Password</string>
-   </property>
-  </widget>
-  <widget class="QLabel" name="label_2">
-   <property name="geometry">
-    <rect>
-     <x>10</x>
-     <y>50</y>
-     <width>111</width>
-     <height>19</height>
-    </rect>
-   </property>
-   <property name="text">
-    <string>Username</string>
-   </property>
+   <layout class="QGridLayout" name="gridLayout">
+    <item row="5" column="0">
+     <widget class="QLineEdit" name="Password">
+      <property name="text">
+       <string/>
+      </property>
+      <property name="echoMode">
+       <enum>QLineEdit::Password</enum>
+      </property>
+     </widget>
+    </item>
+    <item row="2" column="0">
+     <widget class="QLabel" name="label_username">
+      <property name="text">
+       <string>Username</string>
+      </property>
+     </widget>
+    </item>
+    <item row="4" column="0">
+     <widget class="QLabel" name="label_Password">
+      <property name="text">
+       <string>Password</string>
+      </property>
+     </widget>
+    </item>
+    <item row="7" column="0">
+     <widget class="QComboBox" name="fedoraReleases"/>
+    </item>
+    <item row="6" column="0">
+     <widget class="QLabel" name="label_FeodraVersion">
+      <property name="text">
+       <string>Fedora Version</string>
+      </property>
+     </widget>
+    </item>
+    <item row="8" column="0">
+     <widget class="QPushButton" name="saveButton">
+      <property name="text">
+       <string>Save</string>
+      </property>
+     </widget>
+    </item>
+    <item row="3" column="0">
+     <widget class="QLineEdit" name="Username"/>
+    </item>
+   </layout>
   </widget>
  </widget>
  <resources/>
